<template>
  <q-page class="q-px-md q-mt-md">
    <q-btn
      @click="handleClickBack()"
      class="text-center q-mb-sm
"
      color="red"
      icon="arrow_back_ios"
      >กลับ</q-btn
    >
    <q-card>
      <q-card-section>
        <div class="row q-gutter-x-sm">
          <div
            class="col-auto text-right"
            style="line-height: 40px; min-width: 80px;"
          >
            ประเภทเกม
          </div>
          <div class="col">
            <q-checkbox
              v-model="game_type"
              :key="item.code"
              v-for="item in groupList"
              :val="item.code"
              :label="item.code"
            />
          </div>
        </div>
      </q-card-section>
      <q-card-section>
        <div class="row q-gutter-x-sm">
          <div
            class="col-auto text-right"
            style="line-height: 50px; min-width: 80px;"
          >
            ผู้ให้บริการ
          </div>
          <div class="col">
            <q-checkbox
              v-model="provider_code"
              :key="item.code"
              v-for="item in providerList"
              :val="item.code"
              :label="item.code"
            />
            <!-- <q-select
              outlined
              dense
              v-model="provider_code"
              multiple
              :options="providerList"
              option-value="code"
              option-label="name"
              emit-value
              style="min-width: 250px; "
            >
              <template v-if="provider_code.length > 0" v-slot:append>
                <q-icon
                  name="cancel"
                  @click.stop="provider_code = []"
                  class="cursor-pointer"
                />
              </template>
            </q-select> -->
          </div>
        </div>
      </q-card-section>
      <q-card-section>
        <StartDateEndDateFilterComponent :filter="dateFilter" />
      </q-card-section>
      <q-card-section>
        <q-btn color="green" @click.prevent="onSearch" icon="search"
          >ค้นหา</q-btn
        >
      </q-card-section>

      <q-table
        :rows-per-page-options="[15, 25, 50]"
        :pagination.sync="pagination"
        :loading="loading"
        :data="data.docs"
        separator="cell"
        row-key="id"
        @request="onRequest"
      >
        <template slot="header" slot-scope="props" :props="props">
          <q-tr>
            <q-th rowspan="2" class="bg-blue-9 text-white">รายการ</q-th>

            <q-th rowspan="2" class="bg-blue-9 text-white">เลขอ้างอิง</q-th>
            <q-th rowspan="2" class="bg-blue-9 text-white">เวลาคิดผล</q-th>
            <q-th rowspan="2" class="bg-blue-9 text-white">ประเภท</q-th>
            <q-th rowspan="2" class="bg-blue-9 text-white">ผู้ให้บริการ</q-th>
            <q-th rowspan="2" class="bg-blue-9 text-white">Bet</q-th>
            <!-- <q-th rowspan="2" class="bg-blue-9 text-white">ครั้ง</q-th> -->
            <q-th rowspan="2" class="bg-blue-9 text-white">ถือสู้</q-th>
            <q-th colspan="1" class="bg-blue-10 text-white">สมาชิก</q-th>
            <q-th colspan="1" class="bg-blue-10 text-white">เอเย่น</q-th>
            <q-th v-if="role < 5" colspan="1" class="bg-blue-10 text-white"
              >ซีเนียร์</q-th
            >
            <q-th v-if="role < 4" colspan="1" class="bg-blue-10 text-white"
              >ผู้ถือหุ้น</q-th
            >
            <q-th colspan="1" class="bg-blue-10 text-white">คอมปะนี</q-th>
            <q-th v-if="role <= 2" colspan="1" class="bg-blue-10 text-white"
              >Smart Bet</q-th
            >
            <q-th v-if="role < 2" colspan="1" class="bg-blue-10 text-white"
              >Provider</q-th
            >
          </q-tr>
          <q-tr>
            <q-th
              class="bg-light-blue-5 text-white"
              v-for="index in role < 2 ? 7 : 6 - role + 2"
              :key="index"
              >W/L
            </q-th>
          </q-tr>
        </template>
        <template slot="body" slot-scope="props" :props="props">
          <MemberRow
            :provider="providerList"
            :row="props.row"
            :key="props.row.transaction"
          />
        </template>
        <!-- <template slot="bottom" slot-scope="props" :props="props">
          <div class="col">
            <div class="row reverse q-gutter-x-md">
              <div class="col-md-auto">
                <q-btn
                  color="secondary"
                  v-if="
                    props.pagination.rowsPerPage * props.pagination.page <=
                      props.pagination.rowsNumber
                  "
                  size="sm"
                  label="หน้าถัดไป"
                  @click.prevent="props.nextPage()"
                  icon-right="chevron_right"
                />
              </div>
              <div class="col-md-auto">
                <q-btn
                  color="info"
                  v-if="props.pagination.page > 1"
                  size="sm"
                  label="หน้าแรก"
                  @click.prevent="props.firstPage()"
                  icon="first_page"
                />
              </div>
            </div>
          </div>
        </template> -->
        <template v-slot:loading>
          <q-inner-loading showing color="primary" />
        </template>
      </q-table>
    </q-card>
  </q-page>
</template>
<script>
import { mapState, mapGetters, mapActions } from "vuex";
import MemberRow from "./member_member_tr_v3";

import { SessionStorage } from "quasar";
import StartDateEndDateFilterComponent from "components/StartDateEndDateFilterComponent";

export default {
  name: "Report-Member-Member",
  components: { MemberRow, StartDateEndDateFilterComponent },
  data() {
    return {
      data: null,
      dateFilter: {
        startDate:
          new Date().getDate() !== 1
            ? new Date().setDate(1)
            : new Date(
                new Date().getFullYear(),
                new Date().getMonth() - 1
              ).setDate(1),
        startTime: new Date(new Date().setHours(0, 0, 0, 0)),
        endDate: new Date().setDate(new Date().getDate() - 1),
        endTime: new Date(new Date().setHours(23, 59, 59, 999))
      },
      game_type: [],
      provider_code: [],
      loading: false,
      filter: {
        parent_id: this.$route.params.id
      },
      pagination: {
        sortBy: "desc",
        descending: false,
        page: 1,
        rowsPerPage: 25,
        rowsNumber: 0
      },
      groupList: [],
      providerList: []
    };
  },
  beforeRouteEnter(to, from, next) {
    if (to.params.username) {
      to.meta.breadcrumbs[to.meta.breadcrumbs.length - 1].title =
        to.params.username;
      document.title = `${to.params.username} - Report Member`;
    }
    next();
  },
  async created() {
    if (this.settingData) {
      this.settingData.dateTime
        ? (this.dateFilter = this.settingData.dateTime)
        : null;
      this.settingData.game_type
        ? (this.game_type = this.settingData.game_type)
        : null;
      this.settingData.provider_code
        ? (this.provider_code = this.settingData.provider_code)
        : null;
    }

    if (SessionStorage.getItem(`group_list_filter`)) {
      this.groupList = SessionStorage.getItem(`group_list_filter`);
    } else {
      try {
        const {
          data: { results }
        } = await this.load_list();
        if (results) {
          this.groupList = results.filter(
            (item, index) =>
              results.findIndex(r => r.code == item.code) == index
          );
          SessionStorage.set("group_list_filter", this.groupList);
        }
      } catch (ex) {
        this.$dialog.errorException(ex);
      }
    }
    if (SessionStorage.getItem(`provider_list_filter`)) {
      this.providerList = SessionStorage.getItem(`provider_list_filter`);
    } else {
      try {
        const { data } = await this.load_provider();
        if (data) {
          this.providerList = data
            .filter(
              (item, index) => data.findIndex(r => r.code == item.code) == index
            )
            .map(x => {
              return {
                code: x.code,
                name: x.name
              };
            });
          SessionStorage.set("provider_list_filter", this.providerList);
        }
      } catch (ex) {
        this.$dialog.errorException(ex);
      }
    }
    if (Object.keys(this.$route.query).length > 0) {
      const {
        datetime_start,
        datetime_end,
        game_type,
        provider_code
      } = this.$route.query;
      if (datetime_start) {
        this.dateFilter.startDate = dayjs(
          datetime_start.replace(/Z/g, ""),
          "YYYY-MM-DDTHH:mm:ss"
        );
        this.dateFilter.startTime = dayjs(
          datetime_start.replace(/Z/g, ""),
          "YYYY-MM-DDTHH:mm:ss"
        );
      }
      if (datetime_end) {
        this.dateFilter.endDate = dayjs(
          datetime_end.replace(/Z/g, ""),
          "YYYY-MM-DDTHH:mm:ss"
        );
        this.dateFilter.endTime = dayjs(
          datetime_end.replace(/Z/g, ""),
          "YYYY-MM-DDTHH:mm:ss"
        );
      }
      if (game_type) {
        this.game_type = game_type.split(",");
      }
      if (provider_code) {
        this.provider_code = provider_code.split(",");
      }

      await this.onRequest({
        pagination: this.pagination,
        filter: this.filter
      });
    } else {
      this.game_type = this.groupList.map(x => x.code);
    }

    await this.onSearch();
  },
  computed: {
    ...mapState("auth", ["role"]),
    ...mapGetters("report/v2", {
      settingData: "getDateTime"
    })
  },
  methods: {
    ...mapActions("report/v2", ["getTransactionById"]),
    ...mapActions("group/v2", ["load_list"]),
    ...mapActions("provider", { load_provider: "load" }),
    getDateTime(date, time) {
      let dateFormat = "YYYY-MM-DD";
      let timeFormat = "HH:mm:ss";
      return (
        dayjs(
          `${dayjs(date).format(dateFormat)} ${dayjs(time).format(timeFormat)}`,
          "YYYY-MM-DD HH:mm:ss"
        )
          .utc()
          .format(`${dateFormat} ${timeFormat}`) + "Z"
      );
      // return `${dayjs(date).format('YYYY-MM-DD')}T${dayjs(time).format('HH:mm:ss')}Z`;
    },
    getFilterParameter({ filter, pagination }) {
      let datetime_start = undefined;
      let datetime_end = undefined;
      if (this.dateFilter.startDate) {
        if (this.dateFilter.startTime) {
          datetime_start = this.getDateTime(
            this.dateFilter.startDate,
            this.dateFilter.startTime
          );
        } else {
          datetime_start = this.getDateTime(
            this.dateFilter.startDate,
            new Date().setHours(0, 0, 0, 0)
          );
        }
      }
      if (this.dateFilter.endDate) {
        if (this.dateFilter.endTime) {
          datetime_end = this.getDateTime(
            this.dateFilter.endDate,
            this.dateFilter.endTime
          );
        } else {
          datetime_end = this.getDateTime(
            this.dateFilter.endDate,
            new Date().setHours(23, 59, 59, 999)
          );
        }
      }

      //    page: undefined,
      // limit: undefined,
      // start: undefined,
      // end: undefined,
      // providerCode: undefined,
      // typeCode: undefined,
      // id: undefined

      return {
        // ...filter,
        // ...pagination,
        page: pagination.page,
        limit: pagination.rowsPerPage,
        start: datetime_start,
        end: datetime_end,
        id: this.$route.params.id,
        providerCode: this.provider_code.join(",")
          ? this.provider_code.join(",")
          : undefined,
        typeCode: this.game_type.join(",")
          ? this.game_type.join(",")
          : undefined
      };
    },
    async onRequest(props) {
      this.loading = true;
      const { page = 1, rowsPerPage, sortBy, descending } = props.pagination;
      let transaction = undefined;
      if (page > 1) {
        if (this.data.length > 0 && page > this.pagination.page) {
          transaction = this.data[this.data.length - 1].transaction;
        }
      }
      const parameters = this.getFilterParameter(props);
      const { data } = await this.getTransactionById({
        ...parameters,
        transaction: transaction
      });

      this.pagination.page = data.results.page;
      this.pagination.rowsPerPage = data.results.limit;
      this.pagination.rowsNumber = data.results.totalDocs;
      this.data = data.results;
      // this.pagination.page = this.data.page;
      // this.pagination.rowsPerPage = this.data.limit;
      // this.pagination.rowsNumber = this.data.totalPages;
      this.loading = false;
    },
    async onSearch() {
      await this.onRequest({
        pagination: this.pagination,
        filter: this.filter
      });
    },
    handleClickBack() {
      if (SessionStorage.getItem(`from_path`)) {
        const from_path = SessionStorage.getItem(`from_path`);

        const path = from_path.pop();
        SessionStorage.set("from_path", from_path);

        this.$router.replace({ path: path });
      } else {
        this.$router.back();
      }
    }
  }
};
</script>
<style lang="scss">
label {
  margin: 8px 0;
}

.el-input__inner,
.q-field--outlined .q-field__control:before {
  border-color: black;
}
</style>
